package com.hzya.frame.plugin.lets.dingtalk.controller;


import cn.hutool.core.lang.Assert;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.page.PageAttribute;
import com.hzya.frame.plugin.lets.dingtalk.entity.DingU8cBillEntity;
import com.hzya.frame.plugin.lets.dingtalk.service.IDingU8cBillService;
import com.hzya.frame.plugin.lets.dingtalk.vo.U8CCorpVO;
import com.hzya.frame.plugin.lets.entity.BdCorpEntity;
import com.hzya.frame.plugin.lets.util.QueryU8CEntityUtil;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

import static com.hzya.frame.web.entity.BaseResult.getSuccessMessageEntity;


/**
 * 钉钉报表
 */
@RestController
@RequestMapping("/dingReport")
public class DingU8CBillController extends DefaultController {

    protected static Logger logger = LogManager.getLogger(DingU8CBillController.class);


    @Autowired
    private IDingU8cBillService dingU8cBillService;
    @Autowired
    private QueryU8CEntityUtil queryU8CEntityUtil;

    /** 分页查询 */
//    @RequestMapping(value = "queryPaged")
//    @ResponseBody
//    public PageAttribute queryPaged(@RequestBody DingU8cBillEntity dingU8cBillEntity){
//        DingU8cBillEntity dingU8cBillEntity1 = new DingU8cBillEntity();
//        dingU8cBillEntity1.setInitiate(null);
//        PageAttribute<DingU8cBillEntity> dingU8cBillEntityPageAttribute = dingU8cBillService.queryPaged(dingU8cBillEntity1);
//        return dingU8cBillEntityPageAttribute;
//    }

    /** 列表查询 */
    @RequestMapping(value = "queryList")
    @ResponseBody
    public JsonResultEntity queryList(@RequestBody DingU8cBillEntity dingU8cBillEntity){
        List<DingU8cBillEntity> query = dingU8cBillService.query(dingU8cBillEntity);
        return getSuccessMessageEntity("查询成功",query);
    }

    /** 根据Id查询 */
    @RequestMapping(value = "queryById")
    @ResponseBody
    public JsonResultEntity queryById(@RequestBody DingU8cBillEntity dingU8cBillEntity){
        try {
            DingU8cBillEntity query = dingU8cBillService.queryById(dingU8cBillEntity);
            if(query==null){
                Assert.state(false);
            }
            return getSuccessMessageEntity("根据Id查询成功",query);
        }catch (Exception e){
            return getFailureMessageEntity("根据Id查询失败");
        }
    }

    /** 根据Id补推 */
    @RequestMapping(value = "pushById")
    @ResponseBody
    public JsonResultEntity pushById(@RequestBody DingU8cBillEntity dingU8cBillEntity){
        try {
            DingU8cBillEntity query = dingU8cBillService.pushById(dingU8cBillEntity);
            if(query==null){
                Assert.state(false);
            }
            return getSuccessMessageEntity("根据Id补推",query);
        }catch (Exception e){
            return getFailureMessageEntity("根据Id补推失败。",e.getMessage());
        }
    }

    /** U8C 公司查询*/
    @RequestMapping(value = "queryU8CAllCorp")
    @ResponseBody
    public JsonResultEntity queryU8CAllCorp(){
        List<BdCorpEntity> bdCorpEntities = queryU8CEntityUtil.queryBdCorp();
        List<U8CCorpVO> collect = bdCorpEntities.stream().map(index->new U8CCorpVO(index.getUnitcode(),index.getUnitname())).collect(Collectors.toList());
        return getSuccessMessageEntity("U8C 公司查询成功",collect);
    }


}
