package com.hzya.frame.plugin.lets.dingtalk.dao.impl;

import cn.hutool.core.lang.Assert;
import com.hzya.frame.plugin.lets.dingtalk.entity.DingU8cBillEntity;
import com.hzya.frame.plugin.lets.dingtalk.dao.IDingU8cBillDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;
import com.hzya.frame.basedao.dao.MybatisGenericDao;

import java.util.Date;
import java.util.List;

/**
 * (DingU8cBill)表数据库访问层
 * 推送状态
 * ->Y
 * ->N
 * N->N
 * N->Y
 * 回调状态
 * ->Y
 * Y->Y
 * Y->N
 *
 * @author makejava
 * @since 2024-10-28 15:45:32
 */
@Repository("dingU8cBillDao")
public class DingU8cBillDaoImpl extends MybatisGenericDao<DingU8cBillEntity, String> implements IDingU8cBillDao {
    Logger logger = LoggerFactory.getLogger(DingU8cBillDaoImpl.class);

    /**
     * 根据：公司、单据号、实例id、来源D|U
     * ->Y
     * ->N
     * N->N
     * N->Y
     */
    @Override
    public void pushSaveOrUpdate(DingU8cBillEntity dingU8cBillEntityNew) {
        DingU8cBillEntity dingU8cBill = new DingU8cBillEntity();
        dingU8cBill.setU8c_code_corp(dingU8cBillEntityNew.getU8c_code_corp());//公司
        dingU8cBill.setU8c_bill_code(dingU8cBillEntityNew.getU8c_bill_code());//单据号
//        dingU8cBill.setDing_talk_process_id(dingU8cBillEntityNew.getDing_talk_process_id());//实例id
        dingU8cBill.setInitiate(dingU8cBillEntityNew.getInitiate());//来源平台，默认是U，如果发自钉钉会传D
        List<DingU8cBillEntity> query = this.query(dingU8cBill);
        if (query.size() == 0) {
            if("N".equals(dingU8cBillEntityNew.getPush_status())){
                //->N
                this.save(dingU8cBillEntityNew);
            } else if ("Y".equals(dingU8cBillEntityNew.getPush_status())) {
                //->Y
                dingU8cBillEntityNew.setPush_count(1L);
                dingU8cBillEntityNew.setPush_process_ids(dingU8cBillEntityNew.getDing_talk_process_id());
                this.save(dingU8cBillEntityNew);
            }
        } else {
            DingU8cBillEntity dingU8cBillEntity = query.get(0);
            String pushStatus = dingU8cBillEntity.getPush_status();
            String pushStatusNew = dingU8cBillEntityNew.getPush_status();
            if ("N".equals(pushStatus) && "N".equals(pushStatusNew)) {
                //N->N
                dingU8cBill.setId(dingU8cBillEntity.getId());
                dingU8cBill.setModify_time(new Date());
                dingU8cBill.setPush_status("N");
                dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                this.update(dingU8cBill);
            } else if ("N".equals(pushStatus) && "Y".equals(pushStatusNew)) {
                dingU8cBill.setApprove(null);
                //N->Y,可能重复推送
                dingU8cBill.setId(dingU8cBillEntity.getId());
                dingU8cBill.setDing_talk_process_id(dingU8cBillEntityNew.getDing_talk_process_id());
                dingU8cBill.setModify_time(new Date());
                dingU8cBill.setPush_status("Y");
                dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                dingU8cBill.setPush_count(dingU8cBillEntity.getPush_count() == null ? 1L : dingU8cBillEntity.getPush_count() + 1);
                dingU8cBill.setPush_process_ids(dingU8cBillEntity.getPush_process_ids() == null ? dingU8cBillEntityNew.getDing_talk_process_id() : dingU8cBillEntity.getPush_process_ids() + "," + dingU8cBillEntityNew.getDing_talk_process_id());
                this.update(dingU8cBill);
            }
        }
    }

    /**
     * 钉钉回调
     * ->Y 钉钉发起单据，审批不通过的不接
     * Y->Y 钉钉审批通过
     * Y->N 钉钉审批拒绝
     */
    @Override
    public void callBackSaveOrUpdate(DingU8cBillEntity dingU8cBillEntityNew) {
        try {
            DingU8cBillEntity dingU8cBill = new DingU8cBillEntity();
            dingU8cBill.setU8c_code_corp(dingU8cBillEntityNew.getU8c_code_corp());//公司
            dingU8cBill.setU8c_bill_code(dingU8cBillEntityNew.getU8c_bill_code());//单据号
            dingU8cBill.setDing_talk_process_id(dingU8cBillEntityNew.getDing_talk_process_id());//实例id
//        dingU8cBill.setInitiate(dingU8cBillEntityNew.getInitiate());//来源平台，默认是U，如果发自钉钉会传D
            List<DingU8cBillEntity> query = this.query(dingU8cBill);
            if (query.size() == 0) {
                //->Y ->N 钉钉发起单据
                if ("D".equals(dingU8cBillEntityNew.getInitiate())) {
                    this.save(dingU8cBillEntityNew);
                }
            } else if (query.size() == 1) {
                DingU8cBillEntity dingU8cBillEntity = query.get(0);
                if("D".equals(dingU8cBillEntityNew.getInitiate())){
                    if("Y".equals(dingU8cBillEntityNew.getPush_status())){
                        //钉钉发起单据 N->Y
                        dingU8cBill.setId(dingU8cBillEntity.getId());
                        dingU8cBill.setApprove("Y");
                        dingU8cBill.setPush_status("Y");
                        dingU8cBill.setModify_time(new Date());
                        dingU8cBill.setDing_res(dingU8cBillEntityNew.getDing_res());
                        dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                        this.update(dingU8cBill);
                    }else if("N".equals(dingU8cBillEntityNew.getPush_status())){
                        //钉钉发起单据 N->N
                        dingU8cBill.setId(dingU8cBillEntity.getId());
//                        dingU8cBill.setApprove("N");
                        dingU8cBill.setPush_status("N");
                        dingU8cBill.setModify_time(new Date());
                        dingU8cBill.setDing_res(null);
                        dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                        this.update(dingU8cBill);
                    }
                } else if ("U".equals(dingU8cBillEntityNew.getInitiate())) {
                    String pushStatus = dingU8cBillEntity.getPush_status();
                    String pushStatusNew = dingU8cBillEntityNew.getPush_status();
                    String approveNew = dingU8cBillEntityNew.getApprove();
                    //Y->Y 钉钉审批通过
                    //Y->N 钉钉审批拒绝
                    if("Y".equals(pushStatus) && "Y".equals(approveNew)){
                        //Y->Y 钉钉审批通过，推送成功，审批成功
                        dingU8cBill.setId(dingU8cBillEntity.getId());
                        dingU8cBill.setDing_res(dingU8cBillEntityNew.getDing_res());
                        dingU8cBill.setApprove("Y");
                        dingU8cBill.setModify_time(new Date());
                        dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                        this.update(dingU8cBill);
                    } else if ("Y".equals(pushStatus) && "N".equals(approveNew)) {
                        //Y->N 钉钉审批拒绝，推送成功，审批拒绝
                        dingU8cBill.setId(dingU8cBillEntity.getId());
                        dingU8cBill.setApprove("N");
                        dingU8cBill.setPush_status("N");
                        dingU8cBill.setDing_res(null);
                        dingU8cBill.setDing_talk_process_id(null);
                        dingU8cBill.setPush_info(dingU8cBillEntityNew.getPush_info());
                        this.update(dingU8cBill);
                    }
                }

            } else {
                Assert.state(false, "钉钉回调报错,根据公司：{}、单据号：{}、实例id：{}，查询单据不唯一。请检查！", dingU8cBillEntityNew.getU8c_code_corp(), dingU8cBillEntityNew.getU8c_bill_code(), dingU8cBillEntityNew.getDing_talk_process_id());
            }
        } catch (Exception e) {
            logger.error("钉钉回调报错:{}", e);
        }


        return;

    }
}

