package com.hzya.frame.ttxofs.dto.passivestorage;

import com.hzya.frame.ttxofs.basics.ReturnMessageBasics;
import com.hzya.frame.ttxofs.dto.returngoodordersearch.RerturnGoodsOrderSearchData;

import java.util.List;

/**
 * @Author：liuyang
 * @Package：com.hzya.frame.ttxofs.dto.passivestorage
 * @Project：kangarooDataCenterV3
 * @name：PassiveStorageResponse
 * @Date：2025/3/11 18:51
 * @Filename：PassiveStorageResponse
 */
@lombok.Data
public class PassiveStorageResponse extends ReturnMessageBasics {

    private List<Data> data;

    @lombok.Data
    public static class Data {
        private Header header;
        private List<Details> details;
    }

    @lombok.Data
    public static class Header {
        private String id;
        private String clientCode;
        private String companyCode;
        private String facilityCode;
        private String storeCode;
        private String receiptCode;
        private String warehouseCode;
        private String returnWaybillCode;
        private String sourceReturnCode;
        private String sourceOrderCode;
        private String returnOrderCode;
        private String actualRefundAmount;
        private String returnTime;
        private String relatedAt;
        private String status;
        private String created;
        private String createdBy;
        private String lastUpdated;
        private String lastUpdatedBy;
        //让表头能够关联明细表
//        List<PassiveStorageResponse.Details> detailsList;
        //对应的售后订单
        private RerturnGoodsOrderSearchData rerturnGoodsOrderSearchData;
        //对应的销售订单
        private com.hzya.frame.ttxofs.dto.ofssalesordersearch.HeaderDetailsDto headerDetailsDto;
    }

    @lombok.Data
    public static class Details {
        private String id;
        private String headerId;
        private String receiptCode;
        private String clientCode;
        private String companyCode;
        private String skuCode;
        private String skuName;
        private String quantity;
        private String inventorySts;
        private String created;
        private String createdBy;
        private String lastUpdated;
        private String lastUpdatedBy;
        //无源件表头
        private PassiveStorageResponse.Header header;
        //退款完成时间
        private String refundedAt;
    }
}
